"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var utils_1 = require("@react-typed-hooks/utils");
var react_1 = require("react");
function useLocalStorage(key, defaultValue) {
    var _a = react_1.useState(function () {
        if (!utils_1.hasWindow()) {
            return defaultValue;
        }
        try {
            var item = window.localStorage.getItem(key);
            return item ? JSON.parse(item) : defaultValue;
        }
        catch (error) {
            console.error(error);
            return defaultValue;
        }
    }), storedValue = _a[0], setStoredValue = _a[1];
    var setValue = function (value) {
        try {
            var valueToStore = value instanceof Function ? value(storedValue) : value;
            setStoredValue(valueToStore);
            if (!utils_1.hasWindow()) {
                return;
            }
            window.localStorage.setItem(key, JSON.stringify(valueToStore));
        }
        catch (error) {
            console.error(error);
        }
    };
    return [storedValue, setValue];
}
exports.default = useLocalStorage;
//# sourceMappingURL=useLocalStorage.js.map